{$A+,B-,D+,E-,F+,G+,I+,L+,N-,O-,Q+,R+,S+,T-,V-,X-}
{$M 16384,0,655360}

{ Pokusny hrac podla Steva }

  unit hrac5;

interface
  uses typy, Crt;

  procedure Tahaj(a:E_Ihrisko;var b:E_Panaciky);
  procedure Init;

implementation
  const
             SIRKA_ZAR    = 10;
             MOJ_HRAC     =  5;
  type
    TBomba = record
               px, py: integer;
               sila, vek:   integer;
               doVybuchu: integer;
               moja:   boolean;
             end;

    TSuper = record
               px, py: integer;
               smer: integer
             end;

    TMoj   = record
               nextSmer: integer;
               stav: integer
             end;

    TOkolie = record
                dd: array[0..5] of byte;
                ds: array[0..5] of byte;
              end;

    My_Ihrisko = array[1-SIRKA_ZAR..IhriskoX+SIRKA_ZAR,
                       1-SIRKA_ZAR..IhriskoY+SIRKA_ZAR] of integer;

  const
             MAX_BOMB      = 110;
             MAX_SUPEROV   =  40;

             SILA_FIELD    =  2;
             SILA_DETRACT  =  3;
             SILA_ATTRACT  =  5;

             CASTOST_NAHODY=  8;
             SILA_NAHODY   =  6;

             DETRACT_DIAM  =  8;
             ATTRACT_DIAM  =  6;

             DANGER_DEAD   =  7;
             DANGER_DEAD2  =  14;

             STANDARDNA_BOMBA = 4;

             POTENCIAL_HRANICE = 12;
             SIRKA_HRANICE =  3;
             STRMOST_HRANICE  = 4;
             STRMOST_STREDU   = 1;

             MIMO             = -1;
             DNU              = 0;
             ROZOK            = 1;

             NORM             = 0;
             STIHAC           = 1;
             SAMOVRAH         = 2;
  var
    strange:  My_Ihrisko; { staticke pole prislusnossti k ihrisku a ine strange }
    field  :  E_Ihrisko; { staticke pole vhodnosti policka }
    danger :  E_Ihrisko; { konusy - ohrozenie bombami }
    zCas   :  E_Ihrisko; { zvysny cas do vyletenia do vzduchu pre dane policko }
    attract:  E_Ihrisko; { konusy - tvorene supermi }
    detract:  E_Ihrisko; { konusy - tvorene vlastnymi hracmi }

    bomby  :  array[1..MAX_BOMB] of TBomba;
    pocBomb:  integer;
    bombyMap: array[0..IhriskoX+1,0..IhriskoY+1] of boolean;

    superi : array[1.. MAX_SUPEROV] of TSuper;
    pocSuperov: integer;

    moji   : array[1..Panacikov] of TMoj;
    pocMojich: integer;
    pocZivMojich: integer;

    x0, y0, x1, y1, x2, y2: integer;

    ihrisko: ^E_Ihrisko;
    pb     : ^E_Panaciky;

    SamBomby:  integer;
    NormBomby: integer;

    { plni procedura Okolie }
    okBombyS:  TOkolie;
    okBombyM:  TOkolie;
    okSuperi:  TOkolie;
    okZombieS: TOkolie;
    okMoji:    TOkolie;
    okZombieM: TOkolie;

  { vzdialenost dvoch bodov }
  function vzd(x1, y1, x2, y2: integer): integer;
  begin
    vzd:=abs(x1-x2) + abs(y1-y2)
  end;

  { vyrobi konus so stredom cx,cy a diametrom do pola a. }
  procedure FillKonus(var a:E_Ihrisko; x, y, diam, v:integer);
    var i, j: integer;
         pom: integer;
  begin
    inc(a[x, y], v+diam+1);
    for i:=1 to diam do
      for j:=0 to diam-i do
        begin
          pom :=v+diam-i-j+1;
          if strange[x+j, y+i] <> MIMO then
            inc(a[x+j, y+i], pom);
          if strange[x+i, y-j] <> MIMO then
            inc(a[x+i, y-j], pom);
          if strange[x-i, y+j] <> MIMO then
            inc(a[x-i, y+j], pom);
          if strange[x-j, y-i] <> MIMO then
            inc(a[x-j, y-i], pom)
        end
  end;

  { na vytvorenie pola, udavajuceho kolko je do vybuchu bomb }
  procedure ZvysnyCas(x, y, v, diam : integer);
    var i, j, pom: integer;
  begin
    { stred konusu }
    zCas[x, y]:=v;
    for i:=1 to diam do
      for j:=0 to diam-i do
        begin
          if strange[x+j, y+i] <> MIMO then
            zCas[x+j, y+i]:=v;
          if strange[x+i, y-j] <> MIMO then
            zCas[x+i, y-j]:=v;
          if strange[x-i, y+j] <> MIMO then
            zCas[x-i, y+j]:=v;
          if strange[x-j, y-i] <> MIMO then
            zCas[x-j, y-i]:=v
        end
  end;

 { konusy pre danger musia byt spracovavane zvlast, lebo sa nescituje ich
   velkost, ak sa prekryvaju }
  procedure Dan(x, y, v, diam : integer);
    var i, j, pom: integer;
  begin
    { stred konusu }
    if (diam+v) > danger[x, y] then
      danger[x, y]:=2*diam+v;
    for i:=1 to diam do
      for j:=0 to diam-i do
        begin
          pom:=2*(diam-i-j)+v;
          if strange[x+j, y+i] <> MIMO then
            if pom > danger[x+j, y+i] then danger[x+j, y+i]:=pom;
          if strange[x+i, y-j] <> MIMO then
            if pom > danger[x+i, y-j] then danger[x+i, y-j]:=pom;
          if strange[x-i, y+j] <> MIMO then
            if pom > danger[x-i, y+j] then danger[x-i, y+j]:=pom;
          if strange[x-j, y-i] <> MIMO then
            if pom > danger[x-j, y-i] then danger[x-j, y-i]:=pom
        end
  end;

  procedure PridajBombu(x, y, diam, age: integer; whose: boolean);
    var i, j: integer;
        stack: array[1..MAX_BOMB] of integer;
        stackLen: integer;
        nePreskumane: array[1..MAX_BOMB] of boolean;
  begin
    if strange[x,y] = MIMO then
      begin
        x:=x;
      end;
    bombyMap[x, y] := true; { *&* }
    inc(pocBomb);
    with bomby[pocBomb] do
      begin
        px := x;
        py := y;
        sila := diam;
        vek:=age;
        moja:=whose;
        doVybuchu:=sila+2-vek
      end;

    { bomby pre ktore treba overit ci sa nezmenil ich doVybuchu }
    for i:=1 to pocBomb-1 do
      nePreskumane[i]:=true;

    { zisti doVybuchu pre novu bombu }
    for i:=1 to pocBomb-1 do
      if (vzd(x, y, bomby[i].px, bomby[i].py) <= bomby[i].sila) and
         (bomby[pocBomb].doVybuchu > bomby[i].doVybuchu) then
        bomby[pocBomb].doVybuchu:=bomby[i].doVybuchu;

    nePreskumane[pocBomb]:=false;

    { modifikovat doVybuchu pre susedne bomby }
    stackLen:=1;
    stack[1]:= pocBomb;

    while stackLen > 0 do
      begin
        j:=stack[stackLen];
        dec(stackLen);
        for i:=1 to pocBomb-1 do
          if nePreskumane[i] and
              (bomby[j].doVybuchu < bomby[i].doVybuchu) and
              (vzd(bomby[j].px, bomby[j].py, bomby[i].px, bomby[i].py)
                <= bomby[j].sila) then
          begin
            bomby[i].doVybuchu:=bomby[j].doVybuchu;
            inc(stackLen);
            stack[stackLen]:=i;
            nePreskumane[i]:=false;
          end
      end;
    if (whose) then
      Dan(x, y, DANGER_DEAD-bomby[pocBomb].doVybuchu+1, bomby[pocBomb].sila)
    else
      Dan(x, y, DANGER_DEAD-bomby[pocBomb].doVybuchu, bomby[pocBomb].sila);

    { updatne pole zCas }
    for i:=1 to pocBomb do
      if not nePreskumane[i] then
        ZvysnyCas(bomby[i].px, bomby[i].py, bomby[i].doVybuchu, bomby[i].sila)
  end;

  { inicializovat danger, attract, detract na nuly. bomby, pocBomb a bombyMap }
  procedure Init;
    var i, j : integer;
  begin
    for i:=1 to IhriskoX do
      for j:= 1 to IhriskoY do
        begin
          danger[i, j] := 0;
          attract[i, j] := 0;
          detract[i, j] := 0;
          bombyMap[i, j] := false
        end;

    pocBomb := 0;
    { naivna psychologia supera }
    SamBomby:=1;
    NormBomby:=0;
    for i:=1 to Panacikov do
      moji[i].stav := NORM; { normalni }
  end;

  procedure MakeAttract(x, y: integer);
    var i,j, xx, yy, ox, oy, pom, min, mini: integer;
  begin
    { pritahuje len na vzdialenost 4 a 5 }
{    pom:=1;
    for i:=4 to 5 do
      begin
        for j:=1 to i do
          begin
            if strange[x+j, y+j-i] <> MIMO then
              inc(attract[x+j, y+j-i], pom);
            if strange[x-j, y-j+i] <> MIMO then
              inc(attract[x-j, y-j+i], pom);
            if strange[x+i-j, y+j] <> MIMO then
              inc(attract[x+i-j, y+j], pom);
            if strange[x+j-i, y-j] <> MIMO then
              inc(attract[x+j-i, y-j], pom)
          end;
     inc(pom)
    end;
 }
    { najde najblizsieho mojho, len toho bude pritahovat dalej }
    min:=100;
    mini:=-1;
    for i:=1 to Panacikov do
      if pb^[i].Zivy then
        begin
          pom := vzd(x, y, pb^[i].px, pb^[i].py);
          if pom < min then
            begin
              min:=pom;
              mini:=i
            end;
        end;

    if (mini = -1) then
      exit;
    ox:=pb^[mini].px;
    oy:=pb^[mini].py;
    inc(min, 3);
    for i:=0 to 3 do
      begin
        xx:=ox+Smery[i].x;
        yy:=oy+Smery[i].y;
        if strange[xx, yy] <> MIMO then
          attract[xx, yy]:= min-vzd(xx, yy, x, y);
      end
  end;

  function zakerna(x, y: integer): boolean;
    var i, px, py: integer;
      zak: boolean;
  begin
    for i:=0 to 3 do
      begin
        px:=x+Smery[i].x;
        py:=y+Smery[i].y;
        if strange[px, py]<>MIMO then
          zak:=zak or bombyMap[px, py];
      end;
    zakerna:=zak
  end;

  { preskuma okolie bodu }
  procedure Okolie(x, y: integer);
    var i, pom: integer;
  begin
    for i:=0 to 5 do
      begin
        okBombyS.dd[i]:=0;
        okBombyM.dd[i]:=0;
        okSuperi.dd[i]:=0;
        okZombieS.dd[i]:=0;
        okMoji.dd[i]:=0;
        okZombieM.dd[i]:=0;
      end;

    for i:=1 to pocBomb do
      begin
        pom := vzd(x, y, bomby[i].px, bomby[i].py);
        if pom <= 5 then
          if bomby[i].moja then
            inc(okBombyM.dd[pom])
          else  inc(okBombyS.dd[pom]);
      end;

    for i:=1 to pocSuperov do
      begin
        pom := vzd(x, y, superi[i].px, superi[i].py);
        if pom <= 5 then
           if danger[superi[i].px, superi[i].py] < (DANGER_DEAD2-1) then
             inc(okSuperi.dd[pom])
           else inc(okZombieS.dd[pom]);
      end;

    pocZivMojich:=0;
    for i:=1 to Panacikov do
      if pb^[i].Zivy then
        begin
          pom := vzd(x, y, pb^[i].px, pb^[i].py);
          if Moji[i].stav = NORM then
            inc(pocZivMojich);
          if pom <= 5 then
            if Moji[i].stav = NORM then
              inc(okMoji.dd[pom])
            else inc(okZombieM.dd[pom]);
        end;

    okBombyS.ds[0]:=okBombyS.dd[0];
    okBombyM.ds[0]:=okBombyM.dd[0];
    okSuperi.ds[0]:=okSuperi.dd[0];
    okZombieS.ds[0]:=okZombieS.dd[0];
    okMoji.ds[0]:=okMoji.dd[0];
    okZombieM.ds[0]:=okZombieM.dd[0];
    for i:=1 to 5 do
      begin
        okBombyS.ds[i]:=okBombyS.ds[i-1]+okBombyS.dd[i];
        okBombyM.ds[i]:=okBombyM.ds[i-1]+okBombyM.dd[i];
        okSuperi.ds[i]:=okSuperi.ds[i-1]+okSuperi.dd[i];
        okZombieS.ds[i]:=okZombieS.ds[i-1]+okZombieS.dd[i];
        okMoji.ds[i]:=okMoji.ds[i-1]+okMoji.dd[i];
        okZombieM.ds[i]:=okZombieM.ds[i-1]+okZombieM.dd[i];

      end
  end;

  procedure Postras(x, y: integer);
    var i: integer;
  begin
    for i:=1 to pocSuperov do
      if vzd(x, y, superi[i].px, superi[i].py) = 1 then
        Dan(x, y, DANGER_DEAD-3, 5)
  end;

  { podla dodaneho stavu ihriska a nastavi bomby a vsetky s tym suvisiace veci,
    potom danger, attract, detract }
  procedure Rescan(var a:E_Ihrisko; var b: E_Panaciky);
    var i, j, k, rx, ry: integer;
  begin
    i:=1;
    while i <= pocBomb do
      { ak bomba zmizla }
      if a[bomby[i].px, bomby[i].py] <> Bomba then
        begin
          { obnovit struktury o bombach }
          bombyMap[bomby[i].px, bomby[i].py] := false;
          bomby[i] := bomby[pocBomb];
          dec(pocBomb)
        end
      else
        inc(i);

   for i:=1 to pocBomb do
     begin
       inc(bomby[i].vek);
       if bomby[i].doVybuchu > 1 then
       dec(bomby[i].doVybuchu);
    end;

    { resetnut attract a detract, aby boli nove hodnoty korektne }
    for i:=1 to IhriskoX do
      for j:=1 to IhriskoY do
        begin
          attract[i, j] := 0;
          detract[i, j] := 0;
          danger[i,j]   := 0;
          zCas[i, j]    := 200;
        end;

    { naplni pole zCas }
    for i:=1 to pocBomb do
      ZvysnyCas(bomby[i].px, bomby[i].py, bomby[i].doVybuchu, bomby[i].sila);

    { samotny scan }
    pocSuperov:=0;
    for i:=1 to IhriskoX do
      for j:=1 to IhriskoY do
        begin
          case a[i, j] of
            Bomba: if not bombyMap[i, j] then { ak objavime novu bombu }
                     begin
                       inc(NormBomby);
                       PridajBombu(i, j, 5, 1, false);
                       k:=1;
                       if zakerna(i, j) then
                         while k < pocBomb do
                           if (vzd(i, j, bomby[k].px, bomby[k].py) = 1) and
                              (bomby[k].moja=false) and
                               (bomby[k].vek = 2) then
                             begin
                               inc(SamBomby);
                               dec(NormBomby, 2);
                               if NormBomby< 0 then NormBomby := 0;
                               rx:=bomby[k].px;
                               ry:=bomby[k].py;
                               bombyMap[rx, ry] := false;
                               bomby[k] := bomby[pocBomb];
                               dec(pocBomb);
                               PridajBombu(rx, ry, 1, 2, false);
                               k:=pocBomb
                             end
                           else inc(k)
                       else { moze byt rozbuska }
                         begin
                           Okolie(i, j);
                           if (okMoji.ds[4]+okZombieM.ds[4] >=2 ) then
                             Postras(i, j)
                         end
                     end;
            0, MOJ_HRAC: { nic ;-) };
            else { cudzi hrac }
              begin
                inc(pocSuperov);
                with superi[pocSuperov] do
                  begin
                    px:=i;
                    py:=j;
                    { neskor doprogramujem aj smer }
                  end;
  {              MakeAttract(i, j);
                 FillKonus(attract, i, j, ATTRACT_DIAM, 0);}
                 MakeAttract(i, j);
              end;
          end;
        end;

     { aktualizuje mapu DANGEROUS }
     for i:=1 to pocBomb do
      with bomby[i] do
        if moja then
          Dan(px, py, DANGER_DEAD-doVybuchu+1, sila)
        else
          Dan(px, py, DANGER_DEAD-doVybuchu, sila);
     for i:=1 to Panacikov do
       if b[i].zivy then
         begin
           inc(pocMojich);
           FillKonus(detract, b[i].px, b[i].py, DETRACT_DIAM, 3);
         end
  end;

  { nahana superov }
  function Stihaj(var b:E_Panacik; diam: integer): integer;
    var i, pom, r0, r1, r2, rr: longint;
  begin
    rr:=1000; { vela - nema co stat na mieste }
    if strange[x0, y0] = MIMO then
      r0 := rr
    else
      if ihrisko^[x0,y0]<>0 then r0:=rr
      else begin
        r0 := 0;
        if zCas[x0, y0] <=1 then inc(r0, 100);
      end;
    if strange[x1, y1] = MIMO then
      r1 := rr
    else
      if ihrisko^[x1,y1]<>0 then r1:=rr
      else
        begin
          r1 := 0;
          if zCas[x1, y1] <=1 then inc(r1, 100);
        end;
    if strange[x2, y2] = MIMO then
      r2 := rr
    else
      if ihrisko^[x2,y2]<>0 then r2:=rr
      else
        begin
          r2 := 0;
          if zCas[x2, y2] <=1 then inc(r2, 100);
        end;

    for i:=1 to pocSuperov do
      begin
        pom:=vzd(superi[i].px, superi[i].py, b.px, b.py);
        if (pom <= diam+1) then
          begin
            if vzd(superi[i].px, superi[i].py, x0, y0)<=diam then
              dec(r0);
            if vzd(superi[i].px, superi[i].py, x1, y1)<=diam then
              dec(r1);
            if vzd(superi[i].px, superi[i].py, x2, y2)<=diam then
              dec(r1)
          end
      end;
    { vyberie minimum }
    if r0 > r1 then
      if r1 > r2 then
        Stihaj := -1
      else
        Stihaj := 1
    else
      if r0 > r2 then
        Stihaj := -1
      else
        Stihaj := 0
  end;

  { zisti, ci v dalsom tahu panacik urcite zomrie }
  function nabuduceSmrt(var b:E_Panacik): boolean;
    var rr: integer;
        r: array[0..2] of integer;
  begin
    if (strange[x0, y0] = MIMO) then
      r[0]:=zCas[b.px, b.py]
    else r[0]:=zCas[x0, y0];

    if (strange[x1, y1] = MIMO) then
      r[1]:=zCas[b.px, b.py]
    else r[1]:=zCas[x1, y1];

    if (strange[x2, y2] = MIMO) then
      r[2]:=zCas[b.px, b.py]
    else r[2]:=zCas[x2, y2];

    rr:=r[0];
    if rr < r[1] then rr:=r[1];
    if rr < r[2] then rr:=r[2];
    nabuduceSmrt:= rr <= 1
  end;

  function KamikadzeOK(x, y: integer; var diam: integer): boolean;
    var min, i: integer;
  begin
    Okolie(x, y);
    min:=0;
    diam:=0;
    i:=1;
    while (i<5) and (okMoji.ds[i] = 0) do inc(i);
    if (i=5) then i:=4;
    if (i > 1) and (okMoji.ds[i] = 0) and (okSuperi.ds[i+1] > 0) then
      begin
        diam:=i+1;
        KamikadzeOK:=true;
        exit
      end;
    while i<5 do
      begin
        if okSuperi.ds[i+1]-okMoji.ds[i] > min then
          begin
            min:=okSuperi.ds[i]-okMoji.ds[i];
            diam:=i+1;
          end;
        inc(i)
      end;
    if (min>0) then
      KamikadzeOK:=true
    else if (okMoji.ds[4] = 0) and (okZombieS.ds[5]>0) then
      begin
        diam:=5;
        KamikadzeOK:=true
      end
    else KamikadzeOk:=false
  end;

  function HarakiriOK(x, y, h: integer): boolean;
    var min, i: integer;
  begin
    Okolie(x, y);
    HarakiriOK:=(zCas[x, y] >= 3) and (pocZivMojich > 2) and (okSuperi.ds[3]>=h) and (okMoji.ds[3]=1)
  end;

  procedure SkusFintu(var b: E_Panacik);
    var i, pom, min, mini: integer;
  begin
    { ak toto o chvilu vyleri do vzduchu, radsej mizam }
    if zCas[b.px, b.py] <= 3 then
      exit;
    mini:=-1;
    pom:=1000;
    for i:=1 to pocBomb do
      begin
        pom:=vzd(bomby[i].px, bomby[i].py, b.px, b.py);
        if pom<min then
          begin
            min:=pom;
            mini:=i
          end
      end;

    { ak je nejaka bomba a je blizsie nez 4 a stihnem ju urychlit }
    if (mini>0) and (pom<4) and (bomby[mini].doVybuchu > pom+2) then
      begin
        { preskumam okolie urychlovanej bomby }
        Okolie(bomby[mini].px, bomby[mini].py);

        { asi to je sebevrazedna, nepolozim si za chrbat rozbusku }
        if not bomby[mini].moja and ((okMoji.ds[4]+okZombieM.ds[4]) >=2) then
          exit;

        { zatial jednoduchy test }
        if (pom = 1) and (bomby[mini].sila = 3) or
           (pom > 1) and ((okSuperi.ds[4] >= okMoji.ds[3]) or
                          (okMoji.ds[4] = 1) and (okSuperi.ds[5]> 0)) then
          begin
            PridajBombu(b.px, b.py, pom, 0, true);
            b.Poloz:=pom;
          end
      end;
  end;

  { zatial skoro nic }
  procedure StandardUtok(var b: E_Panacik);
  begin
    if (strange[b.px, b.py] = ROZOK) and (zCas[b.px, b.py] >= 5) then
      begin
        Okolie(b.px, b.py);
        if (okSuperi.ds[4] >= okMoji.ds[3]) and
           (okSuperi.ds[5] >= okMoji.ds[4]) then
          begin
                     PridajBombu(b.px, b.py, 5, 0, true); { *&* }
            b.Poloz:=5
          end
      end
  end;

  { je v bezpeci }
  function Chod(var a:E_Ihrisko; var b:E_Panacik): integer;
    var r0, r1, r2, rr: longint;
  begin
     { hodnota na mieste }
    rr := (danger[b.px, b.py] shl 8) +
                 SILA_FIELD*field[b.px, b.py] -
                 SILA_ATTRACT*attract[b.px, b.py]+
                 SILA_DETRACT*detract[b.px, b.py];

    if strange[x0, y0] = MIMO then
      r0 := rr
    else
      if a[x0,y0]<>0 then r0:=rr
      else r0 := (danger[x0, y0] shl 8) +
                 SILA_FIELD*field[x0, y0] -
                 SILA_ATTRACT*attract[x0, y0]+
                 SILA_DETRACT*detract[x0, y0];

    if strange[x1, y1] = MIMO then
      r1 := rr
    else
      if a[x1,y1]<>0 then r1:=rr
      else r1 := (danger[x1, y1] shl 8) +
                 SILA_FIELD*field[x1, y1] -
                 SILA_ATTRACT*attract[x1, y1]+
                 SILA_DETRACT*detract[x1, y1];

    if strange[x2, y2] = MIMO then
      r2 := rr
    else
      if a[x2,y2]<>0 then r2:=rr
      else r2 := (danger[x2, y2] shl 8) +
                 SILA_FIELD*field[x2, y2] -
                 SILA_ATTRACT*attract[x2, y2]+
                 SILA_DETRACT*detract[x2, y2];

    { nahodnost }
    if (random(10) >= CASTOST_NAHODY) then
      begin
        inc(r0, random(SILA_NAHODY));
        inc(r1, random(SILA_NAHODY));
        inc(r2, random(SILA_NAHODY))
      end;

    { vyberie minimum }

    if r0 > r1 then
      if r1 > r2 then
        Chod := -1
      else
        Chod := 1
    else
      if r0 > r2 then
        Chod := -1
      else
        Chod := 0
  end;

  { uteka pred danger, pre rovnake danger tam ked je field mensie }
  function Utekaj(var a:E_Ihrisko; var b:E_Panacik): integer;
    var r0, r1, r2, rr: longint;
  begin
    { hodnota na mieste }
    rr := (danger[b.px, b.py] shl 8)+ SILA_FIELD*field[b.px, b.py]+
          SILA_ATTRACT*attract[b.px, b.py];

    { samotna hodnota vhodnosti - na danger duoraz, mozno by sa dali aj
      vahovat jednotlive prispevky }
    { ak vyskoci z hranice, odpisat ten smer}
    if strange[x0, y0] = MIMO then
      r0 := rr
    else
      if a[x0,y0]<>0 then r0 := rr
      else r0 := (danger[x0, y0] shl 8)+ SILA_FIELD*field[x0, y0]+
                  SILA_ATTRACT*attract[x0, y0];
    if strange[x1, y1] = MIMO then
      r1 := rr
    else
      if a[x1,y1]<>0 then r1 := rr
      else r1 := (danger[x1, y1] shl 8)+ SILA_FIELD*field[x1, y1]+
                  SILA_ATTRACT*attract[x1, y1];
    if strange[x2, y2] = MIMO then
      r2 := rr
    else
      if a[x2,y2]<>0 then r2 := rr
      else r2 := (danger[x2, y2] shl 8)+ SILA_FIELD*field[x2, y2]+
                  SILA_ATTRACT*attract[x2, y2];
    if r0 > r1 then
      if r1 > r2 then
        Utekaj := -1
      else
        Utekaj := 1
    else
      if r0 > r2 then
       Utekaj  := -1
      else
       Utekaj := 0
  end;

 procedure DoHarakiri(var b: E_Panaciky; i, diam: integer);
   var nextSmer, bpx, bpy: integer;
 begin
   nextSmer:=Stihaj(b[i], diam);
   bpx:=b[i].px+Smery[(b[i].smer+4+nextSmer) and 3].x;
   bpy:=b[i].py+Smery[(b[i].smer+4+nextSmer) and 3].y;
   if (strange[bpx, bpy] <> MIMO) and
      (ihrisko^[bpx, bpy] = 0) then
     begin
       PridajBombu(b[i].px, b[i].py, 1, 0, true);
       b[i].Poloz:=1;
       bpx:=b[i].px+Smery[(b[i].smer+4+nextSmer) and 3].x;
       bpy:=b[i].py+Smery[(b[i].smer+4+nextSmer) and 3].y;

       PridajBombu(bpx, bpy, 5, -1, true);
       moji[i].nextSmer:=nextSmer;
       moji[i].stav:=SAMOVRAH;
     end
 end;

  { ******************************  hlavna ********************************* }
  procedure Tahaj(a:E_Ihrisko;var b:E_Panaciky);
    var i,j, bpx, bpy, pocetb, diam, nextSmer:integer;
      ok: boolean;
  begin
    ihrisko:=@a;
    pb:=@b;
    Rescan(a, b);
    pocetb:=0;
    for i:=1 to IhriskoX do
      for j:=1 to IhriskoY do
        if a[i,j] = Bomba then inc(pocetb);
    if (pocetb<>pocBomb) then
      begin
        inc(pocetb);
      end;
    { polozia sa bomby }
    for i:=1 to Panacikov do
      if b[i].Zivy then
        begin
          { vpredu }
          x0 := b[i].px+Smery[b[i].Smer].x;
          y0 := b[i].py+Smery[b[i].Smer].y;

          { vpravo }
          x1 := b[i].px+Smery[(b[i].Smer+1) and 3].x;
          y1 := b[i].py+Smery[(b[i].Smer+1) and 3].y;

          { vlavo }
          x2 := b[i].px+Smery[(b[i].Smer+3) and 3].x;
          y2 := b[i].py+Smery[(b[i].Smer+3) and 3].y;

          { ak je v dosahu bomby }
           if danger[b[i].px, b[i].py] > 0 then
            { ak iste neujde }
            if danger[b[i].px, b[i].py] >= DANGER_DEAD2 then
              { v dalsom tahu vyleti do vzduchu }
              { ak su v okoli superi a nie vlastni, este prilozi bombu aby aj
               oni vyleteli }
              if KamikadzeOK(b[i].px, b[i].py, diam) then
                if nabuduceSmrt(b[i]) then
                  begin
                    b[i].Poloz:=diam;
                    PridajBombu(b[i].px, b[i].py, diam, 0, true);
                    moji[i].stav:=STIHAC;
                    moji[i].nextSmer:=Stihaj(b[i], diam);
                  end
                { zacne sa priblizovat superov, aby mohol pred smrtou uplatnit
                 Kamikadze }
                else
                  begin
                    b[i].Poloz:=diam;
                    PridajBombu(b[i].px, b[i].py, diam, 0, true);
                    moji[i].nextSmer:=Stihaj(b[i], diam);
                  end
              else
                moji[i].nextSmer:=Stihaj(b[i], 4)
            else
              if moji[i].stav = SAMOVRAH then
                begin
                  Okolie(b[i].px, b[i].py);
                  if okSuperi.ds[4]>=2 then
                    begin
                      PridajBombu(b[i].px, b[i].py, 5, 0, true);
                      b[i].Poloz:=5;
                      moji[i].nextSmer:=Stihaj(b[i], 4);
                    end
                  else
                    moji[i].stav := NORM
                end
              { ma sancu ujst, uteka ale skusi fintu }
              else if (HarakiriOK(b[i].px, b[i].py, 2)) then
                DoHarakiri(b, i, 4)
              else SkusFintu(b[i])
          { v bezpeci }
          else
            { ak je okolo vela superov, ze sa oplati samovrah, tak 1 - 5, pripadne
             1 - 1 - 5 }
            if HarakiriOK(b[i].px, b[i].py, 2) then
              DoHarakiri(b, i, 4)
            { standardny utok }
            else StandardUtok(b[i]);
        end;

    { utekanie a vobec pohyb po ihrisku }
    for i:=1 to Panacikov do
      if b[i].Zivy then
        begin
          { vpredu }
          x0 := b[i].px+Smery[b[i].Smer].x;
          y0 := b[i].py+Smery[b[i].Smer].y;

          { vpravo }
          x1 := b[i].px+Smery[(b[i].Smer+1) and 3].x;
          y1 := b[i].py+Smery[(b[i].Smer+1) and 3].y;

          { vlavo }
          x2 := b[i].px+Smery[(b[i].Smer+3) and 3].x;
          y2 := b[i].py+Smery[(b[i].Smer+3) and 3].y;

          if danger[b[i].px, b[i].py] > 0 then
            if (moji[i].stav = STIHAC) or (moji[i].stav = SAMOVRAH) then
              b[i].Zaboc:=moji[i].nextSmer
            else b[i].Zaboc:=Utekaj(a, b[i])
          else b[i].Zaboc:=Chod(a, b[i])
        end;
{    repeat until readkey=' ';}
  end;

  { inicializovat field }
  var i, j, h: integer;

  begin
    { inicizlizacia strange }
    for i:= 1-SIRKA_ZAR to IhriskoX+SIRKA_ZAR do
      for j:= 1-SIRKA_ZAR to IhriskoY+SIRKA_ZAR do
        strange[i, j]:=MIMO;

    { inicializacia fieldu }
    for i:=1 to IhriskoX do
      for j:=1 to IhriskoY do
        begin
          field[i, j]:=0;
          strange[i,j]:=DNU
        end;

    { inicializacia rozkov v strange }
    for i:=1 to 3 do
      for j:=1 to 3 do
        if not((i=1) and (j=3) or (i=3) and (j=1)) then
          begin
            strange[1+i, 1+j]:=ROZOK;
            strange[1+i, IhriskoY-j]:=ROZOK;
            strange[IhriskoX-i, 1+j]:=ROZOK;
            strange[IhriskoX-i, IhriskoY-j]:=ROZOK;
          end;

    { hranicna potencialova bariera }
    h := POTENCIAL_HRANICE;
    for i:= 0 to SIRKA_HRANICE-1 do
      begin
        for j:=1 to IhriskoX do
          begin
            field[1+i, j] := field[1+i, j] + h;
            field[IhriskoX-i, j] := field[IhriskoX-i, j] + h
          end;
        for j:=1 to IhriskoY do
          begin
            field[j, 1+i] := field[j, 1+i] + h;
            field[j, IhriskoY-i] := field[j, IhriskoY-i] + h
          end;

        dec(h, STRMOST_HRANICE);
      end;

    { stredova tupa pyramida }
    for i:=SIRKA_HRANICE+1 to IhriskoX div 2 do
      begin
        for j:=i to IhriskoX - i do
          begin
            field[i, j] := h;
            field[IhriskoX-i+1, j] := h
          end;
        for j:=i to IhriskoY - i do
          begin
            field[j, i] := h;
            field[j, IhriskoY-i+1] := h
          end;
        inc(h, STRMOST_STREDU);
      end
  end.