{$A+,B-,D+,E-,F+,G+,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V-,X-}
{$M 16384,0,655360}

{ Pokusny hrac podla Steva }

  unit hrac4;

interface
  uses typy;

  procedure Tahaj(a:E_Ihrisko;var b:E_Panaciky);
  procedure Init;

implementation
  type
    TBomba = record
               px, py: integer;
               sila,vek:   integer;
               nova:   boolean;
             end;
    My_Ihrisko = array[0..IhriskoX+1, 0..IhriskoY+1] of integer;

  const
             CUDZI         =  true;
             MOJ           =  false;

             MOJ_HRAC      =  4;

             MAX_BOMB      = 110;
             MAX_LONG      = 2147483647;

             SILA_FIELD    =  1;
             SILA_DETRACT  =  3;
             SILA_ATTRACT  =  3;

             CASTOST_NAHODY=  8;
             SILA_NAHODY   =  3;

             ATTRACT_DIAM  =  8;
             DETRACT_DIAM  =  7;

             BEZN_DETRACT  =  9;
             BEZNADEJNE    =  9;

             STANDARDNA_BOMBA = 4;
             FINTA_BOMB    =  2;
             PRIVELA_BOMB  =  6;
             FIRE          = -3;
             FIRE_FINTA    = -7;
             FIRE_OFAJC    = -4;

             POTENCIAL_HRANICE = 10;
             SIRKA_HRANICE =  3;
             STRMOST_HRANICE  = 3; {2}
             STRMOST_STREDU   = 0.5; {0.5}
  var
    field  :  My_Ihrisko; { statiske pole vhodnosti policka }
    danger :  My_Ihrisko; { konusy - ohrozenie bombami }
    attract:  My_Ihrisko; { konusy - tvorene supermi }
    detract:  My_Ihrisko; { konusy - tvorene vlastnymi hracmi }

    bomby  :  array[1..MAX_BOMB] of TBomba;
    pocBomb:  integer;
    bombyMap: array[0..IhriskoX+1,0..IhriskoY+1] of boolean;

    ihrisko: ^E_Ihrisko;

  { vyrobi konus so stredom cx,cy a diametrom do pola a. Ak pridaj, tak
    ho prida, inac ho odpocita }
  procedure FillKonus(var a:My_Ihrisko; x, y, diam:integer);
    var i, j: integer;
         pom: integer;
  begin
    inc(a[x, y], diam+1);
    for i:=1 to diam do
      for j:=0 to diam-i do
        begin
          pom := diam-i-j+1;
          if (x+j <= IhriskoX) and (y+i <= IhriskoY) then
            inc(a[x+j, y+i], pom);
          if (x+i <= IhriskoX) and (y-j >= 1) then
            inc(a[x+i, y-j], pom);
          if (x-i >= 1) and (y+j <= IhriskoY) then
            inc(a[x-i, y+j], pom);
          if (x-j >= 1) and (y-i >= 1) then
            inc(a[x-j, y-i], pom)
        end
  end;

 { konusy pre danger musia byt spracovavane zvlast, lebo sa nescituje ich
   velkost, ak sa prekryvaju }
  procedure Dan(x, y, v, diam : integer);
    var i, j, pom: integer;
  begin
    for i:=0 to diam do
      for j:=0 to diam-i do
        begin
          pom:=diam-i-j+1+v;
          if (x+j <= IhriskoX) and (y+i <= IhriskoY) then
            if pom > danger[x+j, y+i] then danger[x+j, y+i]:=pom;
          if (x+j <= IhriskoX) and (y-i >= 1) then
            if pom > danger[x+j, y-i] then danger[x+j, y-i]:=pom;
          if (x-j >= 1) and (y+i <= IhriskoY) then
            if pom > danger[x-j, y+i] then danger[x-j, y+i]:=pom;
          if (x-j >= 1) and (y-i >= 1) then
            if pom > danger[x-j, y-i] then danger[x-j, y-i]:=pom
        end
  end;


  function Vyskyt(x, y, sila: integer): integer;
    var i, j, pom, suma: integer;
  begin
    suma:=0;
    for i:=1 to sila do
    for j:=0 to sila-i do
      begin
        pom:=sqr(sila-i-j+1);
        if (x+j <= IhriskoX) and (y+i <= IhriskoY) then
           case ihrisko^[x+j, y+i] of
             MOJ_HRAC: inc(suma, pom);
             0, Bomba:;
             else dec(suma, pom);
           end;
        if (x+i <= IhriskoX) and (y-j >= 1) then
           case ihrisko^[x+i, y-j] of
             MOJ_HRAC: inc(suma, pom);
             0, Bomba:;
             else dec(suma, pom);
           end;
        if (x-i >= 1) and (y+j <= IhriskoY) then
           case ihrisko^[x-i, y+j] of
             MOJ_HRAC: inc(suma, pom);
             0, Bomba:;
             else dec(suma, pom);
           end;
        if (x-j >= 1) and (y-i >= 1) then
           case ihrisko^[x-j, y-i] of
             MOJ_HRAC: inc(suma, pom);
             0, Bomba:;
             else dec(suma, pom);
           end;
      end;
    Vyskyt:=suma
  end;
  { inicializovat danger, attract, detract na nuly. bomby, pocBomb a bombyMap }
  procedure Init;
    var i, j : integer;
  begin
    for i:=1 to IhriskoX do
      for j:= 1 to IhriskoY do
        begin
          danger[i, j] := 0;
          attract[i, j] := 0;
          detract[i, j] := 0;
          bombyMap[i, j] := false
        end;

    pocBomb := 0;
  end;

  { podla dodaneho stavu ihriska a nastavi bomby a vsetky s tym suvisiace veci,
    potom danger, attract, detract }
  procedure Rescan(var a: E_Ihrisko);
    var i, j, k: integer;
  begin
    for i:=1 to pocBomb do
      begin
        { ak bomba zmizla }
        if a[bomby[i].px, bomby[i].py] <> Bomba then
          begin
            { obnovit struktury o bombach }
            bombyMap[bomby[i].px, bomby[i].py] := false;
            bomby[i] := bomby[pocBomb];
            dec(pocBomb)
          end;
        { staru bombu oznacime za staru }
        bomby[i].nova := false;
        inc(bomby[i].vek);
      end;

    { resetnut attract a detract, aby boli nove hodnoty korektne }
    for i:=1 to IhriskoX do
      for j:=1 to IhriskoY do
        begin
          attract[i, j] := 0;
          detract[i, j] := 0;
          danger[i,j]   := 0
        end;

    { samotny scan }
    for i:=1 to IhriskoX do
      for j:=1 to IhriskoY do
        begin
          case a[i, j] of
            Bomba: if not bombyMap[i, j] then { ak objavime novu bombu }
                     begin
                       bombyMap[i, j] := true;
                       inc(pocBomb);
                       with bomby[pocBomb] do
                         begin
                           px := i;
                           py := j;
                           sila := 5;
                           nova := true;
                           vek:=0;
                         end
                     end;
       {*** MOJ_HRAC: FillKonus(detract, i, j, DETRACT_DIAM, 1);  {***}
            0, MOJ_HRAC: { nic ;-) };
            else { cudzi hrac }
              FillKonus(attract, i, j, ATTRACT_DIAM);
          end;
        end;

     {aktualizuje mapu DANGEROUS}
     for i:=1 to pocBomb do
      with bomby[i] do dan(px, py, vek, sila);

  end;

  procedure PolozBombu(x, y, pom: integer);
  begin
    bombyMap[x, y] := true;
    inc(pocBomb);
    with bomby[pocBomb] do
      begin
        px := x;
        py := y;
        sila := pom;
        vek:=0;
        nova := false
      end;
    Dan(x, y, 0, bomby[pocBomb].sila);
  end;

  { otestuje, ci je vpredu OK, aby mal kam utekat pred vlastnou bombou }
  function vpreduOk(x, y, Smer: integer): boolean;
    var px, py: integer;
  begin
    { ci vpredu nie je hranica }
    px:= x+4*Smery[Smer].x;
    py:= y+4*Smery[Smer].y;

    if (px > IhriskoX) or (px < 1) or (py > IhriskoY) or (py < 1) then
      begin
        vpreduOk := false;
        exit
      end;

    px:= x+2*Smery[Smer].x;
    py:= y+2*Smery[Smer].y;
    vpreduOk:= (danger[px, py] = 0)
  end;

  { Ak attract - detract prekroci nejaku medzu, poloz bombu. Tu sa da vela
    vyburit - podrobnejsie skumat ci neohrozim privela niekoho vlastneho,
    meditovat nad najvhodnejsou velkostou bomby, klamne manevre s bombami
    velkosti 1 a tak podobne. Tu aj pri SkusFintu nezabudnut updatnut
    pole bomby a prislusne s tym suvisiace struktury.}
  function SkusPolozit(b:E_Panacik): integer;
    var pom: integer;
  begin
    { zatial VELMI jednoducha verzia }
    if (pocBomb <= PRIVELA_BOMB) and
       (attract[b.px, b.py] - detract[b.px, b.py] > FIRE) and
       vpreduOk(b.px, b.py, b.Smer) then
      begin
        SkusPolozit := STANDARDNA_BOMBA;
        { obnovit struktury o bombach }
        PolozBombu(b.px, b.py, STANDARDNA_BOMBA)
      end
{    else if (attract[b.px, b.py] - detract[b.px, b.py] > FIRE_OFAJC) then
      begin
        pom := random(3);
        if (pom > 0) then
          PolozBombu(b.px, b.py, pom);
        SkusPolozit:=pom;
      end}
    else SkusPolozit:=0
  end;

  { ak pribudla nova nepriatelska bomba vo vzdialenosti 2 or 3 (premysliet!)
    polozit vlastnu bombu tak aby ju iniciovala, ak sa pohybujem v smere
    od nepriatelskej a pripadny vybuch nepriatelskej nesposobi v mojich radoch
    vela skody }
  function SkusFintu(var b:E_Panacik): integer;
    var i, pom, oplati, min, poc: integer;
        vlastny: boolean;
  begin
    { kamikadze }
    if (danger[b.px, b.py] > BEZNADEJNE) and
       (detract[b.px, b.py] > BEZN_DETRACT) then
      begin
        SkusFintu := 5;
        PolozBombu(b.px, b.py, 5);
        exit
      end;
    { klasicka finta }
    oplati := 0;
    min := 6;
    poc := 0;
    vlastny := true;
    for i:=1 to pocBomb do
      begin
        pom := abs(bomby[i].px - b.px) + abs(bomby[i].py - b.py);
        if (pom <= 3) then
           if (bomby[i].nova) then
             begin
               oplati:=oplati+Vyskyt(bomby[i].px, bomby[i].py, bomby[i].sila);
               min:=pom;
               inc(poc)
             end
           else vlastny:=false
      end;
    if (oplati < FIRE_FINTA) and (min < 6) and (poc < FINTA_BOMB) and
       vlastny then
      begin
        if min = 1 then pom:=3
        else pom:= min;
        SkusFintu := pom;
        PolozBombu(b.px, b.py, pom);
        inc(bomby[i].vek, 4-pom);
        exit
      end
    else
      SkusFintu := 0;           end;

  { Ak je v bezpeci - kam ist: ( skoro ako utekaj - mozno mozno zlucit )
     vyberie z troch moznych smerov najvhodnejsi takto:
     1. Nejdo do danger nenulove
     2. field+attract-detract najvacsie }
  function Chod(var b:E_Panacik;var a:E_Ihrisko): integer;
    var x0, y0, x1, y1, x2, y2: integer;
        r0, r1, r2: longint;
  begin
    { vpredu }
    x0 := b.px+Smery[b.Smer].x;
    y0 := b.py+Smery[b.Smer].y;

    { vpravo }
    x1 := b.px+Smery[(b.Smer+1) and 3].x;
    y1 := b.py+Smery[(b.Smer+1) and 3].y;

    { vlavo }
    x2 := b.px+Smery[(b.Smer+3) and 3].x;
    y2 := b.py+Smery[(b.Smer+3) and 3].y;

    { samotna hodnota vhodnosti - na danger duoraz, mozno by sa dali aj
      vahovat jednotlive prispevky }
    { ak vyskoci z hranice, odpisat ten smer}
    if (x0 < 1) or (x0 > IhriskoX) or (y0 < 1) or (y0 > IhriskoY) then
      r0 := MAX_LONG
    else
      if a[x0,y0]<>0 then r0:=MAX_LONG
      else r0 := (danger[x0, y0] shl 8) +
                 SILA_FIELD*field[x0, y0] -
                 SILA_ATTRACT*attract[x0, y0]+
                 SILA_DETRACT*detract[x0, y0];

    if (x1 < 1) or (x1 > IhriskoX) or (y1 < 1) or (y1 > IhriskoY) then
      r1 := MAX_LONG
    else
      if a[x1,y1]<>0 then r1:=MAX_LONG
      else r1 := (danger[x1, y1] shl 8) +
                 SILA_FIELD*field[x1, y1] -
                 SILA_ATTRACT*attract[x1, y1]+
                 SILA_DETRACT*detract[x1, y1];

    if (x2 < 1) or (x2 > IhriskoX) or (y2 < 1) or (y2 > IhriskoY) then
      r2 := MAX_LONG
    else
      if a[x2,y2]<>0 then r2:=MAX_LONG
      else r2 := (danger[x2, y2] shl 8) +
                 SILA_FIELD*field[x2, y2] -
                 SILA_ATTRACT*attract[x2, y2]+
                 SILA_DETRACT*detract[x2, y2];

    { nahodnost }
    if (random(10) >= CASTOST_NAHODY) then
      begin
        inc(r0, random(SILA_NAHODY));
        inc(r1, random(SILA_NAHODY));
        inc(r2, random(SILA_NAHODY))
      end;

    { vyberie minimum }
    if r0 > r1 then
      if r1 > r2 then
        Chod := -1
      else
        Chod := 1
    else
      if r0 > r2 then
        Chod := -1
      else
        Chod := 0
  end;



   { Ak je v bneezpeci - kam ist: ( skoro ako utekaj - mozno mozno zlucit )
     vyberie z troch moznych smerov najvhodnejsi takto:
     1. Nejdo do danger nenulove
     2. field+attract-detract najvacsie }
  function Utekaj(var b:E_Panacik; var a: E_Ihrisko): integer;
    var x0, y0, x1, y1, x2, y2: integer;
        r0, r1, r2: longint;
  begin
    { vpredu }
    x0 := b.px+Smery[b.Smer].x;
    y0 := b.py+Smery[b.Smer].y;

    { vpravo }
    x1 := b.px+Smery[(b.Smer+1) and 3].x;
    y1 := b.py+Smery[(b.Smer+1) and 3].y;

    { vlavo }
    x2 := b.px+Smery[(b.Smer+3) and 3].x;
    y2 := b.py+Smery[(b.Smer+3) and 3].y;

    { samotna hodnota vhodnosti - na danger duoraz, mozno by sa dali aj
      vahovat jednotlive prispevky }
    { ak vyskoci z hranice, odpisat ten smer}
    if (x0 < 1) or (x0 > IhriskoX) or (y0 < 1) or (y0 > IhriskoY) then
      r0 := MAX_LONG
    else
      if a[x0,y0]<>0 then r0 := MAX_LONG
      else r0 := (danger[x0, y0] shl 7)+ SILA_FIELD*field[x0, y0];

    if (x1 < 1) or (x1 > IhriskoX) or (y1 < 1) or (y1 > IhriskoY) then
      r1 := MAX_LONG
    else
      if a[x1,y1]<>0 then r1 := MAX_LONG
      else r1 := (danger[x1, y1] shl 7)+ SILA_FIELD*field[x1, y1];

    if (x2 < 1) or (x2 > IhriskoX) or (y2 < 1) or (y2 > IhriskoY) then
      r2 := MAX_LONG
    else
      if a[x2,y2]<>0 then r2 := MAX_LONG
      else r2 := (danger[x2, y2] shl 7)+ SILA_FIELD*field[x2, y2];

    if r0 > r1 then
      if r1 > r2 then
        Utekaj := -1
      else
        Utekaj := 1
    else
      if r0 > r2 then
       Utekaj  := -1
      else
       Utekaj := 0
  end;

  { hlavna }
  procedure Tahaj(a:E_Ihrisko;var b:E_Panaciky);
    var i:integer;
  begin
    ihrisko:=@a;
    Rescan(a);
    for i:=1 to Panacikov do
      if b[i].Zivy then
        FillKonus(detract, b[i].px, b[i].py, DETRACT_DIAM);

    for i:=1 to Panacikov do
      if b[i].Zivy then
        { ak je v dosahu bomby tak uteka }
        if danger[b[i].px, b[i].py] > 0 then
          begin
            b[i].Zaboc := Utekaj(b[i],a);
            b[i].Poloz := SkusFintu(b[i]);
          end
        { neohrozeny, chod na najlepsiu poziciu a pripadne poloz bombu }
        else
          begin
            b[i].Zaboc := Chod(b[i],a);
            b[i].Poloz := SkusPolozit(b[i]);
          end
  end;

  { inicializovat field }
  var i, j, h: integer;

  begin
    { hranicna potencialova bariera }
    h := POTENCIAL_HRANICE;
    for i:= 0 to SIRKA_HRANICE-1 do
      begin
        for j:=i+1 to IhriskoX - i do
          begin
            field[1+i, j] := h;
            field[IhriskoX-i, j] := h
          end;
        for j:=i+1 to IhriskoY - i do
          begin
            field[j, 1+i] := h;
            field[j, IhriskoY-i] := h
          end;

        dec(h, STRMOST_HRANICE);
      end;
    for i:=SIRKA_HRANICE+1 to IhriskoX - SIRKA_HRANICE do
      for j:=SIRKA_HRANICE+1 to IhriskoY - SIRKA_HRANICE do
        { so vzdialenostou od stredu to klesa }
        field[i, j] := round((IhriskoX - 2*SIRKA_HRANICE -
                       abs((IhriskoX div 2) - i) -
                       abs((IhriskoY div 2) - j)) * STRMOST_STREDU);
  end.