  program proboj;
    uses hrac1,hrac2,hrac3,hrac4,hrac5,grafika,typy,crt;

{############################################################################}
{########################< VNUTORNE POLIA >##################################}
{############################################################################}

    var {Ktori hraci prave hraju}
        Hraju:array[1..Hracov] of boolean;
        {Ktori uz hrali}
        Hrali:array[1..Hracov,1..Hracov] of integer;
        {Vysledky}
        Vysle:Vysledok;
        {Kolko este maju zivych hracov}
        Zivych:array[1..Hracov] of integer;
        {Tahy jednotlivych hracov}
        Tahaj:array[1..Hracov] of ProcTahaj;
        Init:array[1..Hracov] of ProcInit;
        {Externe Ihrisko}
        DE_Ihrisko:E_Ihrisko;
        {Externy Panacikovia}
        DE_Panaciky:E_Panaciky;
        {Interny Panacikovia}
        DI_Panaciky:array[1..Hracov] of I_Panaciky;
        {Interne Ihrisko}
        Ihrisko:I_Ihrisko;
{############################################################################}
{########################<     QUEUE       >#################################}
{############################################################################}
    const QSize=200;

    var q:array[0..QSize] of record x,y,s:integer; end;
        qr,qw:integer;

    procedure QInit;
      begin
        qr:=0;
        qw:=0;
      end;

    procedure QPush(x,y,s:integer);
      begin
        q[qw].x:=x;
        q[qw].y:=y;
        q[qw].s:=s;
        if qw<QSize then qw:=qw+1 else qw:=0;
      end;

    procedure QPop(var x,y,s:integer);
      begin
        x:=q[qr].x;
        y:=q[qr].y;
        s:=q[qr].s;
        if qr<QSize then qr:=qr+1 else qr:=0;
      end;

    function QEmpty:boolean;
      begin
        QEmpty:=(qr=qw);
      end;

{############################################################################}
{########################<    PROCEDURY    >#################################}
{############################################################################}
    {Priprav komunikacne premenne}
    procedure Nastav(Hrac:integer;var a:E_Ihrisko;var b:E_Panaciky);
      var i,j:integer;
      begin
        {Nastav pole E_Ihrisko}
        for i:=1 to IhriskoX do begin
          for j:=1 to IhriskoY do begin
            if Ihrisko[i,j].Hrac=0 then begin
              a[i,j]:=0;
            end else begin
              if Ihrisko[i,j].Bomba=0 then begin
                a[i,j]:=Ihrisko[i,j].Hrac;
              end else begin
                a[i,j]:=Bomba;
              end;
            end;
          end;
        end;
        {Nastav pole E_Panaciky}
        for i:=1 to Panacikov do begin
          b[i].Zivy:=DI_Panaciky[Hrac][i].Zivy;
          if DI_Panaciky[Hrac][i].Zivy then begin
            b[i].Smer:=DI_Panaciky[Hrac][i].Smer;
            b[i].Zaboc:=0;
            b[i].Poloz:=0;
            b[i].px:=DI_Panaciky[Hrac][i].Px;
            b[i].py:=DI_Panaciky[Hrac][i].Py;
          end;
        end;
      end;

    {Vybuchni bombu a iniciuj okolite}
    procedure Explode(x,y:integer);
      var i,j,s:integer;
      begin
        QInit;
        QPush(x,y,Ihrisko[x,y].bomba);
        Ihrisko[x,y].Bomba:=0;
        Ihrisko[x,y].Hrac:=0;
        while not QEmpty do begin
          QPop(x,y,s);
          VymazBombu(x,y);
          VybuchniBombu(Ihrisko,x,y,s);
          for i:=-s to s do for j:=-s to s do begin
            if (x+i>=1) and (y+j>=1) and (x+i<=IhriskoX) and (y+j<=IhriskoY) and (abs(i)+abs(j)<=s) then begin
              if Ihrisko[x+i,y+j].Bomba>0 then begin
  	        QPush(x+i,y+j,Ihrisko[x+i,y+j].Bomba);
                Ihrisko[x+i,y+j].Bomba:=0;
                Ihrisko[x+i,y+j].Hrac:=0;
              end else begin
                if Ihrisko[x+i,y+j].Cislo>0 then begin
                  if DI_Panaciky[Ihrisko[x+i,y+j].Hrac][Ihrisko[x+i,y+j].Cislo].Zivy then begin
                    DI_Panaciky[Ihrisko[x+i,y+j].Hrac][Ihrisko[x+i,y+j].Cislo].Zivy:=false;
                    Dec(Zivych[Ihrisko[x+i,y+j].Hrac]);
                    VymazPanacika(Ihrisko[x+i,y+j].Hrac,x+i,y+j);
                    Ihrisko[x+i,y+j].Hrac:=0;
                    Ihrisko[x+i,y+j].Cislo:=0;
                  end;
                end;
              end;
            end;
          end;
        end;
      end;

    {Urob jeden tah}
    procedure JedenTah;
      var i,j,k,nx,ny,ox,oy:integer;
          bol:boolean;
      begin
        for i:=1 to Hracov do if Hraju[i] then begin
          {Nastav mu hodnoty}
          Nastav(i,DE_Ihrisko,DE_Panaciky);
          {Nech potiahne}
          Tahaj[i](DE_Ihrisko,DE_Panaciky);
          {Teraz potiahneme jeho panacikov}
          for j:=1 to Panacikov do begin
            if DI_Panaciky[i][j].zivy then begin
              {Zmen smer panacika}
              DI_Panaciky[i][j].smer:=(DI_Panaciky[i][j].smer+4+DE_Panaciky[j].Zaboc) mod 4;
              {Zisti, kam sa posunie}
              ox:=DI_Panaciky[i][j].px;
              oy:=DI_Panaciky[i][j].py;
              nx:=ox+Smery[DI_Panaciky[i][j].smer].x;
              ny:=oy+Smery[DI_Panaciky[i][j].smer].y;
              {Moze s posunut?}
              if not ((nx>=1) and (nx<=IhriskoX) and (ny>=1) and (ny<=IhriskoY)) 
			     or (Ihrisko[nx,ny].Hrac>0) or (Ihrisko[nx,ny].Bomba>0) then begin
                nx:=ox;
                ny:=oy;
              end else begin
                {Zmaz stare policko/obnov nove policko}
                Ihrisko[nx,ny].Hrac:=i;
                Ihrisko[nx,ny].Cislo:=j;
                Ihrisko[ox,oy].Hrac:=0;
                Ihrisko[ox,oy].Cislo:=0;
                {Chce polozit bombu?}
                VymazPanacika(i,ox,oy);
                if (DE_Panaciky[j].Poloz>=1) and (DE_Panaciky[j].Poloz<=5) then begin
                  {Poloz Bombu!}
                  Ihrisko[ox,oy].Hrac:=i;
                  Ihrisko[ox,oy].Bomba:=DE_Panaciky[j].Poloz;
                  Ihrisko[ox,oy].Cas:=DE_Panaciky[j].Poloz+2;
                  NakresliBombu(Ihrisko[ox,oy].Bomba,ox,oy);
                end;
                NakresliPanacika(i,nx,ny);
              end;
              DI_Panaciky[i][j].px:=nx;
              DI_Panaciky[i][j].py:=ny;
            end;
          end;
          {Teraz vybuchneme jeho bomby}
          bol:=false;
          for j:=1 to IhriskoX do for k:=1 to IhriskoY do begin
            if (Ihrisko[j,k].Hrac=i) and (Ihrisko[j,k].Bomba>0) then begin
              Dec(Ihrisko[j,k].Cas);
              if Ihrisko[j,k].Cas=0 then begin
			    Explode(j,k);
                bol:=true;
              end;
            end;
          end;
          if not bol then delay(100);
        end;
      end;

   {Je uz koniec hry?}
   function Koniec:boolean;
     var i,j:integer;
     begin
       j:=0;
       for i:=1 to Hracov do if Hraju[i] and (Zivych[i]>0) then j:=j+1;
       Koniec:=(j<=1);
     end;

   {Odohraj jednu hru}
   procedure Hra;
     var i:integer;
     begin
       for i:=1 to Hracov do if Hraju[i] then Init[i];
       i:=1;
{       repeat until readkey=' ';}
       while (i<TahovNaHru) and (not Koniec) do begin
         Jedentah;
         inc(i);
       end;
     end;

   {Daj i-teho panacika hraca h na policko x,y smerom s}
   procedure Dajna(h,i,x,y,s:integer);
     begin
       Ihrisko[x,y].Hrac:=h;
       Ihrisko[x,y].Cislo:=i;
       DI_Panaciky[h][i].zivy:=true;
       DI_Panaciky[h][i].Px:=x;
       DI_Panaciky[h][i].Py:=y;
       DI_Panaciky[h][i].Smer:=s;
       NakresliPanacika(h,x,y);
     end;

   {Odohraj Turnaj}
   procedure Turnaj;
     var i,j,k,l,t,bk,bl:integer;
         popa:array[1..2*Panacikov] of record x,y:integer; end;
         popb:array[1..Ihriskox,1..IhriskoY] of integer;

     procedure Vyhodnot;
       begin
         if Zivych[k]>Zivych[l] then
	   bk:=bk+3+(Zivych[k] div 2)
	 else
	  if Zivych[k]<Zivych[l] then
	     bl:=bl+3+(Zivych[l] div 2)
	  else begin
            bk:=bk+1;
            bl:=bl+1;
          end;
       end;

     procedure Init;
       var i,j:integer;
       begin
         {Vycisti ihrisko}
         NakresliIhrisko;
         for i:=1 to IhriskoX do for j:=1 to IhriskoY do begin
           Ihrisko[i,j].Hrac:=0;
           Ihrisko[i,j].Cislo:=0;
           Ihrisko[i,j].Bomba:=0;
           Ihrisko[i,j].Cas:=0;
         end;
         Zivych[k]:=Panacikov;
         Zivych[l]:=Panacikov;
       end;

     begin
{       Init;
       for i:=1 to Hracov do begin
         Hraju[i]:=true;
         ZIvych[i]:=Panacikov;
         for j:=1 to Panacikov do begin
           Dajna(i,j,j*2,i*4-1,0);
         end;
       end;
       Hra;}

       {Vynuluj Pole}
       for i:=1 to Hracov do for j:=1 to Hracov do Hrali[i,j]:=0;
       {Hraj}

       for t:=1 to Hracov*(Hracov-1) div 2 do begin
         {Kto s kym?}
         repeat
           k:=random(Hracov)+1;
           l:=random(Hracov)+1;
         until (k<>l) and (Hrali[k,l]=0);
         Hrali[k,l]:=1;
         Hrali[l,k]:=1;
         bl:=0;
         bk:=0;
         {Oznam zapas}
         OznamZapas(l,k);
 {        repeat until readkey=' ';}
         {Idu hrat Niekolko druhov zapasov}
         for j:=1 to Hracov do if (j=k) or (j=l) then Hraju[j]:=true else Hraju[j]:=false;

         {Druh1 - Sachovy zaciatok}
         Init;
         for j:=1 to Panacikov do begin
           Dajna(k,j,j*2-1,1,2);
           Dajna(l,j,j*2 ,20,0);
         end;
         Hra;
         {Vyhodnot}
         Vyhodnot;
         OznamVysledok(k,l,bk,bl,' Prieben stav: ');
{         repeat until readkey=' ';}

         {Generovanie nah. rozlozenia}
         for i:=1 to IhriskoX do for j:=1 to IhriskoY do popb[i,j]:=-1;
         for j:=1 to 2*Panacikov do begin
           repeat
             popa[j].x:=random(20)+1;
             popa[j].y:=random(20)+1;
           until popb[popa[j].x,popa[j].y]=-1;
           popb[popa[j].x,popa[j].y]:=random(4);
         end;
         {Druh2 - Random}
         Init;
         for j:=1 to Panacikov do begin
           Dajna(k,j,popa[j].x,popa[j].y,popb[popa[j].x,popa[j].y]);
           Dajna(l,j,popa[j+Panacikov].x,popa[j+Panacikov].y,popb[popa[j].x,popa[j].y]);
         end;
         Hra;
         {Vyhodnot}
         Vyhodnot;
         OznamVysledok(k,l,bk,bl,' Prieben stav: ');
{         repeat until readkey=' ';}

         {Druh3 - Random}
         Init;
         for j:=1 to Panacikov do begin
           Dajna(l,j,popa[j].x,popa[j].y,popb[popa[j].x,popa[j].y]);
           Dajna(k,j,popa[j+Panacikov].x,popa[j+Panacikov].y,popb[popa[j].x,popa[j].y]);
         end;
         Hra;
         {Vyhodnot}
         Vyhodnot;
         OznamVysledok(k,l,bk,bl,' Prieben stav: ');
{         repeat until readkey=' ';}

         {Druh4 - Mixy zaciatok}
         Init;
         for j:=1 to Panacikov do begin
           Dajna(k,j,j*2-1,1+(j mod 2)*18,2);
           Dajna(l,j,j*2 ,20-((j+1) mod 2)*18,0);
         end;
         Hra;
         {Vyhodnot}
         Vyhodnot;
         OznamVysledok(k,l,bk,bl,' Konen vsledok: ');
{         repeat until readkey=' ';}

         Vysle[k][l]:=bk;
         Vysle[l][k]:=bl;
       end;

       KoniecTurnaja(Vysle);
       repeat until readkey=' ';
     end;

  begin
    randseed:=6;
    {randomize;}
    Tahaj[1]:=Hrac1.Tahaj;
    Tahaj[2]:=Hrac2.Tahaj;
    Tahaj[3]:=Hrac3.Tahaj;
    Tahaj[4]:=Hrac4.Tahaj;
    Tahaj[5]:=Hrac5.Tahaj;
    Init[1]:=Hrac1.Init;
    Init[2]:=Hrac2.Init;
    Init[3]:=Hrac3.Init;
    Init[4]:=Hrac4.Init;
    Init[5]:=Hrac5.Init;
    Turnaj;
  end.